-- CLASS ngSituacaoExemplar
CREATE TABLE SITUACAOEXEMPLAR (
ID_SITUACAOEXEMPLAR                               INT PRIMARY KEY,
CODIGO                                            VARCHAR(32) NOT NULL,
DESCRICAO                                         VARCHAR(128) NOT NULL
);

-- CLASS ngLivro
CREATE TABLE LIVRO (
ID_LIVRO                                          INT PRIMARY KEY,
TITULO                                            VARCHAR(200) NOT NULL,
AUTOR                                             VARCHAR(128) NOT NULL,
EDICAO                                            VARCHAR(64) NOT NULL
);

-- CLASS ngCliente
CREATE TABLE CLIENTE (
ID_CLIENTE                                        INT PRIMARY KEY,
NOME                                              VARCHAR(256) NOT NULL,
CPF                                               VARCHAR(11) NOT NULL
);

-- CLASS ngExemplar
CREATE TABLE EXEMPLAR (
ID_EXEMPLAR                                       INT PRIMARY KEY,
CODIGO                                            VARCHAR(32) NOT NULL,
ID_SITUACAOEXEMPLAR                               INT NOT NULL,
ID_LIVRO                                          INT NOT NULL
);

-- CLASS ngExemplar
-- RELATION ngSituacaoExemplar(0..*) <----> (1..1)ngExemplar
ALTER TABLE EXEMPLAR ADD CONSTRAINT F2999ID_SITUACAOEXEMPLAR FOREIGN KEY (ID_SITUACAOEXEMPLAR) REFERENCES SITUACAOEXEMPLAR(ID_SITUACAOEXEMPLAR);

CREATE INDEX I2999ID_SITUACAOEXEMPLAR ON EXEMPLAR (ID_SITUACAOEXEMPLAR);

-- RELATION ngLivro(0..*) <----> (1..1)ngExemplar
ALTER TABLE EXEMPLAR ADD CONSTRAINT F2999ID_LIVRO FOREIGN KEY (ID_LIVRO) REFERENCES LIVRO(ID_LIVRO);

CREATE INDEX I2999ID_LIVRO ON EXEMPLAR (ID_LIVRO);

-- CLASS ngEmprestimo
CREATE TABLE EMPRESTIMO (
ID_EMPRESTIMO                                     INT PRIMARY KEY,
RETIRADA                                          DATETIME NOT NULL,
PREVISTADEV                                       DATETIME NOT NULL,
DATADEV                                           DATETIME NOT NULL,
ID_EXEMPLAR                                       INT NOT NULL,
ID_CLIENTE                                        INT NOT NULL
);

-- CLASS ngEmprestimo
-- RELATION ngExemplar(0..*) <----> (1..1)ngEmprestimo
ALTER TABLE EMPRESTIMO ADD CONSTRAINT F3000ID_EXEMPLAR FOREIGN KEY (ID_EXEMPLAR) REFERENCES EXEMPLAR(ID_EXEMPLAR);

CREATE INDEX I3000ID_EXEMPLAR ON EMPRESTIMO (ID_EXEMPLAR);

-- RELATION ngCliente(0..*) <----> (1..1)ngEmprestimo
ALTER TABLE EMPRESTIMO ADD CONSTRAINT F3000ID_CLIENTE FOREIGN KEY (ID_CLIENTE) REFERENCES CLIENTE(ID_CLIENTE);

CREATE INDEX I3000ID_CLIENTE ON EMPRESTIMO (ID_CLIENTE);